
    <!DOCTYPE html>
    <html>
      <head>
        <meta charset="utf-8">
      </head>
      <body>
<div class="marpit"><svg data-marpit-svg="" viewBox="0 0 1280 5000"><foreignObject width="1280" height="5000"><section id="1" data-marpit-fragments="26">
<h1>Javalin</h1>
<h2>Ссылки</h2>
<ul>
<li data-marpit-fragment="1"><a href="https://javalin.io/documentation#handler-groups">Группировка маршрутов при помощи методов routes() и path()</a></li>
<li data-marpit-fragment="2"><a href="https://javalin.io/documentation#endpoint-handlers">Создание динамических маршрутов, имеющих внутри себя изменяемы части</a></li>
<li data-marpit-fragment="3"><a href="https://javalin.io/documentation#context">Методы для работы с контекстом в Javalin</a></li>
<li data-marpit-fragment="4"><a href="https://ebean.io/docs/query/update">Обновление данных в базе при помощи ORM</a></li>
<li data-marpit-fragment="5"><a href="https://ebean.io/docs/query/delete">Удаление данных из базы при помощи ORM</a></li>
</ul>
<h2>src/main/java/exercise/App.java</h2>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="6">
<p>В методе <code>addRoutes()</code> добавьте в приложение маршруты для полного CRUD статьи:</p>
<ul>
<li data-marpit-fragment="7"><em>GET /articles</em> — список всех статей</li>
<li data-marpit-fragment="8"><em>GET /articles/{id}</em> — просмотр конкретной статьи</li>
<li data-marpit-fragment="9"><em>GET /articles/new</em> — вывод формы создания новой статьи</li>
<li data-marpit-fragment="10"><em>POST /articles</em> — создание новой статьи</li>
<li data-marpit-fragment="11"><em>GET /articles/{id}/edit</em> — вывод формы редактирования статьи</li>
<li data-marpit-fragment="12"><em>POST /articles/{id}/edit</em> — обновление данных статьи</li>
<li data-marpit-fragment="13"><em>GET /articles/{id}/delete</em> — вывод страницы с подтверждением удаления статьи</li>
<li data-marpit-fragment="14"><em>POST /articles/{id}/delete</em> — удаление статьи</li>
</ul>
<p>Обратите внимание, что маршруты можно сгруппировать по пути. Воспользуйтесь для этого методами <code>routes()</code> и <code>path()</code>. Класс контроллер <code>ArticleController</code>, который будет обрабатывать запросы и обработчики уже созданы в файле <em>controllers/ArticleController.java</em>.</p>
</li>
<li data-marpit-fragment="15">
<p>Изучите код в методе <code>getTemplateEngine</code>. Посмотрите, как происходит подключение и настройка шаблонизатора Thymeleaf.</p>
</li>
</ul>
<h2>src/main/java/exercise/controllers/ArticleController.java</h2>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="16">
<p>Допишите обработчик <code>editArticle</code>, который выводит форму редактирования статьи. Статья тоже должна допускать редактирование названия, содержания и категории. На странице редактирования должны отображаться данные статьи, поэтому понадобится получить из базы данные статьи, а также список всех категорий и передать их в шаблон. Для статьи атрибут назовите &quot;article&quot;, а для списка статей — &quot;categories&quot;. Шаблон для обработчика уже создан и находится по пути <em>articles/edit.html</em></p>
</li>
<li data-marpit-fragment="17">
<p>Допишите обработчик <code>updateArticle</code>, который обновляет данные статьи в базе. После обновления статьи создайте flash-сообщение об успешном редактировании статьи и выполните редирект на страницу просмотра всех статей. Для создания flash-сообщения потребуется установить в сессию атрибут &quot;flash&quot; с текстом сообщения.</p>
</li>
</ul>
<pre><code class="language-java">ctx.sessionAttribute(<span class="hljs-string">&quot;flash&quot;</span>, <span class="hljs-string">&quot;Статья успешно создана&quot;</span>);
</code></pre>
<ul>
<li data-marpit-fragment="18">
<p>Допишите обработчик <code>deleteArticle</code>, который выводит страницу с подтверждением удаления статьи. Текст подтверждения должен содержать название статьи, поэтому потребуется получить статью из базы и передать её в шаблон. Чтобы вывод в шаблоне был корректный, назовите атрибут &quot;article&quot;. Шаблон для этого обработчика также создан и расположен по пути <em>articles/delete.html</em></p>
</li>
<li data-marpit-fragment="19">
<p>Допишите обработчик <code>destroyArticle</code>, который удаляет данные статьи из базы. После  удаления статьи создайте flash-сообщение об успешном редактировании статьи и выполните редирект на страницу просмотра всех статей.</p>
</li>
</ul>
<h2>Подсказки</h2>
<ul>
<li data-marpit-fragment="20">
<p>Изучите методы для работы с контекстом</p>
</li>
<li data-marpit-fragment="21">
<p>Для получения динамической части маршрута используйте метод <code>pathParamAsClass()</code>. Так можно получить получить данные сразу в нужном формате.</p>
</li>
</ul>
<pre><code class="language-java"><span class="hljs-keyword">long</span> id = ctx.pathParamAsClass(<span class="hljs-string">&quot;id&quot;</span>, Long.class).getOrDefault(<span class="hljs-keyword">null</span>);
</code></pre>
<ul>
<li data-marpit-fragment="22">
<p>Для получения данных формы используйте метод <code>formParam()</code></p>
</li>
<li data-marpit-fragment="23">
<p>Чтобы установить атрибут в запрос и таким образом передать данные в шаблон, используйте метод <code>attribute()</code></p>
</li>
<li data-marpit-fragment="24">
<p>Для редиректа используйте метод <code>redirect()</code></p>
</li>
<li data-marpit-fragment="25">
<p>Для рендеринга шаблона используйте метод <code>render()</code>, передав туда путь к шаблону</p>
</li>
<li data-marpit-fragment="26">
<p>Чтобы обновить категорию статью, вам понадобится передать в метод <code>set()</code> id новой категории</p>
</li>
</ul>
</section>
<script>!function(){"use strict";const t="marpitSVGPolyfill:setZoomFactor,",e=Symbol();let r,o;function n(n){const i="object"==typeof n&&n.target||document,a="object"==typeof n?n.zoom:n;window[e]||(Object.defineProperty(window,e,{configurable:!0,value:!0}),window.addEventListener("message",(({data:e,origin:r})=>{if(r===window.origin)try{if(e&&"string"==typeof e&&e.startsWith(t)){const[,t]=e.split(","),r=Number.parseFloat(t);Number.isNaN(r)||(o=r)}}catch(t){console.error(t)}})));let l=!1;Array.from(i.querySelectorAll("svg[data-marpit-svg]"),(t=>{var e,n,i,s;t.style.transform||(t.style.transform="translateZ(0)");const c=a||o||t.currentScale||1;r!==c&&(r=c,l=c);const d=t.getBoundingClientRect(),{length:u}=t.children;for(let r=0;r<u;r+=1){const o=t.children[r],a=o.getScreenCTM();if(a){const t=null!==(n=null===(e=o.x)||void 0===e?void 0:e.baseVal.value)&&void 0!==n?n:0,r=null!==(s=null===(i=o.y)||void 0===i?void 0:i.baseVal.value)&&void 0!==s?s:0,l=o.firstElementChild,{style:u}=l;u.transformOrigin||(u.transformOrigin=`${-t}px ${-r}px`),u.transform=`scale(${c}) matrix(${a.a}, ${a.b}, ${a.c}, ${a.d}, ${a.e-d.left}, ${a.f-d.top}) translateZ(0.0001px)`}}})),!1!==l&&Array.from(i.querySelectorAll("iframe"),(({contentWindow:e})=>{null==e||e.postMessage(`${t}${l}`,"null"===window.origin?"*":window.origin)}))}r=1,o=void 0;const i=(t,e,r)=>{if(t.getAttribute(e)!==r)return t.setAttribute(e,r),!0};function a({once:t=!1,target:e=document}={}){const r="Apple Computer, Inc."===navigator.vendor?[n]:[];let o=!t;const a=()=>{for(const t of r)t({target:e});!function(t=document){Array.from(t.querySelectorAll('svg[data-marp-fitting="svg"]'),(t=>{var e;const r=t.firstChild,o=r.firstChild,{scrollWidth:n,scrollHeight:a}=o;let l,s=1;if(t.hasAttribute("data-marp-fitting-code")&&(l=null===(e=t.parentElement)||void 0===e?void 0:e.parentElement),t.hasAttribute("data-marp-fitting-math")&&(l=t.parentElement),l){const t=getComputedStyle(l),e=Math.ceil(l.clientWidth-parseFloat(t.paddingLeft||"0")-parseFloat(t.paddingRight||"0"));e&&(s=e)}const c=Math.max(n,s),d=Math.max(a,1),u=`0 0 ${c} ${d}`;i(r,"width",`${c}`),i(r,"height",`${d}`),i(t,"preserveAspectRatio",getComputedStyle(t).getPropertyValue("--preserve-aspect-ratio")||"xMinYMin meet"),i(t,"viewBox",u)&&t.classList.toggle("__reflow__")}))}(e),o&&window.requestAnimationFrame(a)};return a(),()=>{o=!1}}const l=Symbol(),s=document.currentScript;((t=document)=>{if("undefined"==typeof window)throw new Error("Marp Core's browser script is valid only in browser context.");if(t[l])return t[l];const e=a({target:t}),r=()=>{e(),delete t[l]};Object.defineProperty(t,l,{configurable:!0,value:r})})(s?s.getRootNode():document)}();
</script></foreignObject></svg></div>
      </body>
    </html>
  
